<template>
  <div class="box-graphics">
    <div class="d-flex justify-end">
      <configuration
        class=""
        @reloadPlanificationCharts="reloadCharts"
      ></configuration>
      <seguimiento class="ml-5"></seguimiento>
    </div>
    <h3 class="text-center tway-header-1">Presupuesto</h3>

    <div class="resumen">
      <div class="resumen-title tway-violet--text">Resumen</div>
      <div class="resumen-content">
        <div class="resumen-detail">
          <div
            class="resumen-detail-item"
            v-for="(resume, index) in summaryBudget.resume"
            :key="index"
          >
            <div>{{ resume.description }}:</div>
            <div class="resumen-detail-item-amount">
              <div>{{ resume.value }}</div>
              <div>{{ resume.percentage }}</div>
            </div>
          </div>
        </div>
        <div class="resumen-bar">
          <VueApexCharts
            :series="summaryBudget.series"
            :options="summaryBudget.options"
            type="bar"
            height="150"
            class="full"
          />
        </div>
      </div>
    </div>
    <div class="box-multi-graphics">
      <div class="seguimiento">
        <div class="seguimiento-periodo">
          <div class="tway-violet--text mt-2 ml-2">
            Seguimiento por Periodo
            <ToolTips
              description="Ratio del gasto real sobre  el Presupuestado, por mes."
            />
          </div>
          <VueApexCharts
            :series="followUPPerPeriod.series"
            :options="followUPPerPeriod.options"
            type="line"
            class="full"
          />
        </div>
        <div class="seguimiento-costo">
          <div class="tway-violet--text mt-2 ml-2">
            Seguimiento por Unidad de Costo
            <ToolTips
              description="Gasto sobre Presupuesto por Unidad de Costo."
            />
          </div>
          <BarWithMarkers
            v-if="followUPByCostCenter.series.length > 0"
            :series="followUPByCostCenter.series"
            :options="followUPByCostCenter.options"
          />
        </div>
      </div>
      <div class="centro-costo">
        <div class="tway-violet--text mt-2 ml-2">
          Unidad de Costo
          <ToolTips
            description="Distribución del Gasto, por unidad de costo, por mes."
          />
        </div>
        <StackedColumns
          width="500"
          height="770"
          :series="costCenter.series"
          :options="costCenter.options"
        />
      </div>
    </div>
  </div>
</template>

<script>
import Configuration from "../../components/pmo/presupuesto/configuration.vue";
import Seguimiento from "../../components/pmo/presupuesto/seguimiento.vue";
import BudgetService from "@/services/pmo/presupuesto/budgetService";
// import StackedBars100 from "../../components/charts/pmo/apex/bar/StackedBars100";
//import LineColumn from "../../components/charts/pmo/apex/mixed/LineColumn";
import BarWithMarkers from "../../components/charts/pmo/apex/bar/BarWithMarkers";
import StackedColumns from "../../components/charts/pmo/apex/column/StackedColumns";
import VueApexCharts from "vue-apexcharts";
import ToolTips from "../../components/pmo/utils/ToolTips";

export default {
  name: "Budget",
  components: {
    Configuration,
    Seguimiento,
    // StackedBars100,
    //LineColumn,
    BarWithMarkers,
    StackedColumns,
    VueApexCharts,
    ToolTips,
  },
  data() {
    return {
      charts: {
        timeLine: {
          serie: null,
        },
        stacked: {
          serie: [],
        },
      },
      serieStacked: [],
      summaryBudget: {
        resume: [],
        series: [],
        options: {
          chart: {
            fontFamily: "Josefin Sans, Arial, sans-serif",
            type: "bar",
            height: 150,
            width: 1250,
            stacked: true,
            toolbar: {
              show: false,
            },
          },
          plotOptions: {
            bar: {
              horizontal: true,
            },
          },
          stroke: {
            width: 0,
            colors: ["#fff"],
            curve: "smooth",
            lineCap: "round",
            dashArray: 0,
          },
          title: {
            text: undefined,
          },
          xaxis: {
            categories: [""],
            labels: {
              formatter: function (val) {
                return val;
              },
            },
          },
          yaxis: {
            title: {
              text: undefined,
            },
          },
          colors: ["#16C62E", "#9f9f9f", "#7319D5", "#D7263D", "#4A148C"],
          tooltip: {
            y: {
              formatter: function (val) {
                return "MM$" + val;
              },
            },
          },
          fill: {
            opacity: 1,
          },
          legend: {
            position: "left",
            horizontalAlign: "left",
            offsetX: 0,
            offsetY: 0,
          },
        },
      },
      followUPPerPeriod: {
        series: [],
        options: {
          chart: {
            fontFamily: "Josefin Sans, Arial, sans-serif",
            height: 550,
            type: "line",
            stacked: false,
            toolbar: {
              show: false,
              offsetX: 0,
              offsetY: 0,
              tools: {
                download: true,
                selection: true,
                zoom: true,
                zoomin: true,
                zoomout: true,
                pan: true,
                reset: true | '<img src="/static/icons/reset.png" width="20">',
                customIcons: [],
              },
            },
          },
          colors: ["#16C62E", "#AEEA00", "#4A148C", "#7319D5"],
          stroke: {
            width: [4, 4, 2],
          },
          plotOptions: {
            bar: {
              columnWidth: "60%",
            },
          },
          dataLabels: {
            enabled: true,
            enabledOnSeries: [2],
            formatter: function (val) {
              return val + " %";
            },
          },
          xaxis: {
            categories: [
              "Enero 2022",
              "Febrero 2022",
              "Marzo 2022",
              "Abril 2022",
              "Mayo 2022",
              "Junio 2022",
              "Julio 2022",
              "Agosto 2022",
            ],
          },
          yaxis: [
            {
              seriesName: "Presupuesto",
              axisTicks: {
                show: true,
              },
              axisBorder: {
                show: true,
              },
              title: {
                text: "MM$",
              },
            },
            {
              seriesName: "Presupuesto",
              show: false,
            },
            {
              opposite: true,
              seriesName: "Gasto/Presupuesto",
              axisTicks: {
                show: true,
              },
              axisBorder: {
                show: true,
              },
              title: {
                text: "Gasto/Presupuesto %",
              },
            },
          ],
          tooltip: {
            shared: false,
            intersect: true,
            x: {
              show: false,
            },
          },
          legend: {
            horizontalAlign: "left",
            offsetX: 40,
          },
        },
      },
      followUPByCostCenter: {
        options: {
          chart: {
            fontFamily: "Josefin Sans, Arial, sans-serif",
            type: "bar",
            height: 430,
            toolbar: {
              show: false,
            },
          },
          plotOptions: {
            bar: {
              horizontal: true,
              dataLabels: {
                position: "top",
              },
            },
          },
          colors: ["#16C62E", "#7319D5"],
          dataLabels: {
            enabled: true,
            offsetX: -6,
            style: {
              fontSize: "12px",
              colors: ["#fff"],
            },
          },
          stroke: {
            show: true,
            width: 1,
            colors: ["#fff"],
          },
          tooltip: {
            shared: true,
            intersect: false,
          },
          xaxis: {
            categories: [
              "Operaciones",
              "Tecnología",
              "Comercial",
              "Administración",
              "Recursos Humanos",
              "Legal",
            ],
          },
        },
        series: [],
      },
      costCenter: {
        options: {
          chart: {
            fontFamily: "Josefin Sans, Arial, sans-serif",
            type: "bar",
            height: 650,
            width: 1200,
            stacked: true,
            toolbar: {
              show: false,
            },
          },
          plotOptions: {
            bar: {
              horizontal: false,
            },
          },
          // Violeta Claro:'#7319D5' - Violeta Oscuro: '#4A148C' - Verde Oscuro: '#AEEA00' - Verde Claro:'#16C62E' - Gris: '#7F7F7F'
          colors: ["#7F7F7F", "#4A148C", "#16C62E", "#7319D5", "#AEEA00"],
          stroke: {
            width: 1,
            colors: ["#fff"],
          },
          title: {
            text: undefined,
          },
          xaxis: {
            categories: [
              "Enero",
              "Febrero",
              "Marzo",
              "Abril",
              "Mayo",
              "Junio",
              "Julio",
            ],
            labels: {
              formatter: function (val) {
                return val;
              },
            },
          },
          yaxis: {
            title: {
              text: undefined,
            },
          },
          tooltip: {
            y: {
              formatter: function (val) {
                return "UF " + val;
              },
            },
          },
          fill: {
            opacity: 1,
          },
          legend: {
            position: "bottom",
            horizontalAlign: "left",
            offsetX: 0,
          },
        },
        series: [],
      },
    };
  },
  methods: {
    async callService() {
      await BudgetService.getSummaryBudget()
        .then((data) => {
          this.summaryBudget.series = data.series;
          this.summaryBudget.resume = data.resume;
        })
        .catch((err) => console.dir(err));

      await BudgetService.getPeriodTrack()
        .then((data) => {
          this.followUPPerPeriod.series = data;
        })
        .catch((err) => console.dir(err));

      await BudgetService.getTrackByCostCenter()
        .then((data) => {
          this.followUPByCostCenter.series = data;
        })
        .catch((err) => console.dir(err));

      await BudgetService.getCostCenter()
        .then((data) => {
          this.costCenter.series = data;
        })
        .catch((err) => console.dir(err));
    },
  },
  async mounted() {
    this.callService();
  },
};
</script>

<style lang="scss" scoped>
.box-graphics {
  max-width: 1400px;
  min-width: 1100px;
  height: 100vh;
}
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}

.resumen {
  display: flex;
  flex-direction: column;
  width: 100%;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  justify-content: flex-start;
  margin: 25px 0px 15px 0px;
  font-size: 15px;
  padding: 20px;
}
.resumen-content {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  border: none !important;
}

.resumen > .resumen-content > .resumen-detail {
  width: 23%;
  display: flex;
  flex-direction: column;
  margin-top: 50px;
  font-size: 13px !important;
}
.resumen > .resumen-content > .resumen-detail > .resumen-detail-item {
  width: 100%;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}

.resumen
  > .resumen-content
  > .resumen-detail
  > .resumen-detail-item
  > .resumen-detail-item-amount {
  display: flex;
  width: 50%;
  justify-content: space-between;
}

.resumen-detail-item-amount > div:first-child {
  text-align: right;
  width: 65%;
}

.resumen > .resumen-content > .resumen-bar {
  display: flex;
  width: 80%;
  height: auto;
}
.resumen-title {
  display: block;
  flex-direction: column;
  float: left;
  justify-content: space-between;
  font-size: 18px;
}
.resumen-content {
  display: flex;
  flex-direction: row;
  width: 100%;
  border: solid black 1px;
  justify-content: space-between;
  margin-bottom: 15px;
}

.box-multi-graphics {
  display: flex;
  height: 100vh;
  height: 100%;
  min-height: 100%;
  justify-content: space-between;
  padding-bottom: 100px;
}

.seguimiento {
  width: 47%;
  display: flex;
  flex-direction: column;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  margin: 0px 0px 50px 10px;
  height: 850px;
}
.seguimiento-costo {
  width: 100%;
  margin: 2px;
}
.seguimiento-periodo {
  width: 100%;
  margin: 2px;
}
.centro-costo {
  width: 47%;
  padding: 0px;
  margin-top: 50px;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  margin: 0px 10px 50px 0px;
  height: 850px;
}
.full {
  width: 100%;
}
</style>
